#ifndef _MCAN_CONFIG_H
#define _MCAN_CONFIG_H

#include "MCAN_Driver.h"
#include "MCAN_Internal.h"

#if(MCAN0_ENABLED)

#define MCAN0_RX_STANDARD_FILTERS 0 //MAX 128
#define MCAN0_RX_EXTENDED_FILTERS 0 //MAX 64
#define MCAN0_RX_DEDICATED_BUFFERS 0 //MAX 64
#define MCAN0_RX_FIFO0_LENGHT 0 //MAX 64
#define MCAN0_RX_FIFO1_LENGHT 0 //MAX 64
#define MCAN0_TX_DEDICATED_BUFFERS 0
#define MCAN0_TX_FIFO_LENGHT 32 //MAX 32 TOTAL
#define MCAN0_TX_EVENT_FIFO_LENGHT 0 //MAX 32

#define MCAN0_BITTIMINGS_PRESCALER 6
#define MCAN0_BITTIMINGS_SJW 1
#define MCAN0_BITTIMINGS_SEG1 13
#define MCAN0_BITTIMINGS_SEG2 2

#define MCAN0_GLOBAL_FILTER_CONFIG CAN_GFC_ANFE(2) | CAN_GFC_ANFS(0)
#define MCAN0_GLOBAL_EXTIDANDMASK 0x1FFFFFFF
#define MCAN0_STDFILTERS_PRELOAD 0
#define MCAN0_EXTFILTERS_PRELOAD 0


extern MCAN_CONFIGURATION MCAN0_Config;

#define MCAN0_MESSAGE_RAM_SIZE (MCAN0_RX_STANDARD_FILTERS +     \
	MCAN0_RX_EXTENDED_FILTERS * WORDS_PER_EXTENDED_FILTER +     \
	MCAN0_RX_FIFO0_LENGHT * WORDS_PER_FIFO_ELEMENT +            \
	MCAN0_RX_FIFO1_LENGHT * WORDS_PER_FIFO_ELEMENT +            \
	MCAN0_RX_DEDICATED_BUFFERS * WORDS_PER_FIFO_ELEMENT +       \
	MCAN0_TX_EVENT_FIFO_LENGHT * WORDS_PER_TX_EVENT_ELEMENT +   \
	MCAN0_TX_DEDICATED_BUFFERS * WORDS_PER_FIFO_ELEMENT +       \
	MCAN0_TX_FIFO_LENGHT * WORDS_PER_FIFO_ELEMENT)

#endif

#if(MCAN1_ENABLED)

#define MCAN1_RX_STANDARD_FILTERS 0 //MAX 128
#define MCAN1_RX_EXTENDED_FILTERS 0 //MAX 64
#define MCAN1_RX_DEDICATED_BUFFERS 0 //MAX 64
#define MCAN1_RX_FIFO0_LENGHT 0 //MAX 64
#define MCAN1_RX_FIFO1_LENGHT 0 //MAX 64
#define MCAN1_TX_DEDICATED_BUFFERS 0 
#define MCAN1_TX_FIFO_LENGHT 0 //MAX 32 TOTAL 
#define MCAN1_TX_EVENT_FIFO_LENGHT 0 //MAX 32

#define MCAN1_BITTIMINGS_PRESCALER  12
#define MCAN1_BITTIMINGS_SJW        1
#define MCAN1_BITTIMINGS_SEG1       13
#define MCAN1_BITTIMINGS_SEG2       2

#define MCAN1_GLOBAL_FILTER_CONFIG (CAN_GFC_ANFS(0) | CAN_GFC_ANFE(0))
#define MCAN1_GLOBAL_EXTIDANDMASK 0x1FFFFFFF
#define MCAN1_STDFILTERS_PRELOAD 0
#define MCAN1_EXTFILTERS_PRELOAD 0

extern MCAN_CONFIGURATION MCAN1_Config;

#define MCAN1_MESSAGE_RAM_SIZE (MCAN1_RX_STANDARD_FILTERS +     \
	MCAN1_RX_EXTENDED_FILTERS * WORDS_PER_EXTENDED_FILTER +     \
	MCAN1_RX_FIFO0_LENGHT * WORDS_PER_FIFO_ELEMENT +            \
	MCAN1_RX_FIFO1_LENGHT * WORDS_PER_FIFO_ELEMENT +            \
	MCAN1_RX_DEDICATED_BUFFERS * WORDS_PER_FIFO_ELEMENT +       \
	MCAN1_TX_EVENT_FIFO_LENGHT * WORDS_PER_TX_EVENT_ELEMENT +   \
	MCAN1_TX_DEDICATED_BUFFERS * WORDS_PER_FIFO_ELEMENT +       \
	MCAN1_TX_FIFO_LENGHT * WORDS_PER_FIFO_ELEMENT)

#endif

//Configuration checks
#if(MCAN0_ENABLED)

#if(MCAN0_RX_STANDARD_FILTERS > 128)
    #error MCAN0_RX_STANDARD_FILTERS > 128: MCAN0: Maximum 128 Rx Standard Filters
#endif

#if(MCAN0_RX_EXTENDED_FILTERS > 64)
    #error MCAN0_RX_EXTENDED_FILTERS > 64: MCAN0: Maximum 64 Rx Extended Filters
#endif

#if(MCAN0_RX_DEDICATED_BUFFERS > 64)
    #error MCAN0_RX_DEDICATED_BUFFERS > 64: MCAN0: Maximum 64 Dedicated Rx Buffers
#endif

#if(MCAN0_RX_FIFO0_LENGHT > 64)
    #error MCAN0_RX_FIFO0_LENGHT > 64: MCAN0: Maximum Lenght for Rx FIFO 0 is 64 
#endif

#if(MCAN0_RX_FIFO1_LENGHT > 64)
    #error MCAN0_RX_FIFO1_LENGHT > 64: MCAN0: Maximum Lenght for Rx FIFO 1 is 64 
#endif

#if(MCAN0_TX_EVENT_FIFO_LENGHT > 32)
    #error MCAN0_TX_EVENT_FIFO_LENGHT > 32: MCAN0: Maximum Lenght for Tx EVENT FIFO is 64 
#endif

#if((MCAN0_TX_DEDICATED_BUFFERS + MCAN0_TX_FIFO_LENGHT) > 32)
    #error MCAN0_TX_DEDICATED_BUFFERS + MCAN0_TX_FIFO_LENGHT) > 32: MCAN0: Maximum Lenght for all Tx Buffers (Dedicated + Fifo) is 32
#endif

#if(MCAN0_BITTIMINGS_PRESCALER && MCAN0_BITTIMINGS_SJW && MCAN0_BITTIMINGS_SEG1 && MCAN0_BITTIMINGS_SEG2)
#define MCAN0_CONFIG_BITTIMINGS (CAN_NBTP_NSJW(MCAN0_BITTIMINGS_SJW - 1) | CAN_NBTP_NBRP(MCAN0_BITTIMINGS_PRESCALER - 1) | CAN_NBTP_NTSEG1(MCAN0_BITTIMINGS_SEG1 - 1) | CAN_NBTP_NTSEG2(MCAN0_BITTIMINGS_SEG2 - 1))
#else
#warning MCAN0: Bit Timings are not configured at compile-time, ensure bit timings are set via MCAN_ConfigureBitTimings() before enabling peripheral
#define MCAN0_CONFIG_BITTIMINGS 0
#endif

#endif

#if(MCAN1_ENABLED)

#if(MCAN1_RX_STANDARD_FILTERS > 128)
    #error MCAN1_RX_STANDARD_FILTERS > 128: MCAN1: Maximum 128 Rx Standard Filters
#endif

#if(MCAN1_RX_EXTENDED_FILTERS > 64)
    #error MCAN1_RX_EXTENDED_FILTERS > 64: MCAN1: Maximum 64 Rx Extended Filters
#endif

#if(MCAN1_RX_DEDICATED_BUFFERS > 64)
    #error MCAN1_RX_DEDICATED_BUFFERS > 64: MCAN1: Maximum 64 Dedicated Rx Buffers
#endif

#if(MCAN1_RX_FIFO0_LENGHT > 64)
    #error MCAN1_RX_FIFO0_LENGHT > 64: MCAN1: Maximum Lenght for Rx FIFO 0 is 64 
#endif

#if(MCAN1_RX_FIFO1_LENGHT > 64)
    #error MCAN1_RX_FIFO1_LENGHT > 64: MCAN1: Maximum Lenght for Rx FIFO 1 is 64 
#endif

#if(MCAN1_TX_EVENT_FIFO_LENGHT > 32)
    #error MCAN1_TX_EVENT_FIFO_LENGHT > 32: MCAN1: Maximum Lenght for Tx EVENT FIFO is 64 
#endif

#if((MCAN1_TX_DEDICATED_BUFFERS + MCAN1_TX_FIFO_LENGHT) > 32)
    #error MCAN1_TX_DEDICATED_BUFFERS + MCAN1_TX_FIFO_LENGHT) > 32: MCAN1: Maximum Lenght for all Tx Buffers (Dedicated + Fifo) is 32
#endif

#if(MCAN1_BITTIMINGS_PRESCALER && MCAN1_BITTIMINGS_SJW && MCAN1_BITTIMINGS_SEG1 && MCAN1_BITTIMINGS_SEG2)
#define MCAN1_CONFIG_BITTIMINGS (CAN_NBTP_NSJW(MCAN1_BITTIMINGS_SJW - 1) | CAN_NBTP_NBRP(MCAN1_BITTIMINGS_PRESCALER - 1) | CAN_NBTP_NTSEG1(MCAN1_BITTIMINGS_SEG1 - 1) | CAN_NBTP_NTSEG2(MCAN1_BITTIMINGS_SEG2 - 1))
#else
#warning MCAN1: Bit Timings are not configured at compile-time, ensure bit timings are set via MCAN_ConfigureBitTimings() before enabling peripheral
#define MCAN1_CONFIG_BITTIMINGS 0
#endif

#endif

#endif //MCAN_CONFIG_H